/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package worldclient;

//Imports
import java.io.*;
import java.net.*;

/**
 *
 * @author Guilherme
 */
public class WorldClient {
    private int speed = 0;
    private int id = 0;
    private int angle = 0;
    private OutputStream outStream;
    //private ObjectInputStream inStream;
    private PrintStream worldElement;
    private Socket socket;
    private boolean movingForward = false;
    private boolean movingBackward = false;
    
//    public static void main(String[] args) //throws ClassNotFoundException 
//    {
//           new WorldClient(0);
//    }
    
    public WorldClient(int value) //throws ClassNotFoundException
    {
       try {
            String response;
            //Create a socket
            socket = new Socket("127.0.0.1", 4011);
        
            //create stream for data transfering
            outStream = socket.getOutputStream();
            //inStream = new ObjectInputStream(socket.getInputStream());
            worldElement = new PrintStream(outStream);
            
            worldElement.println("game");
            //response = (String)inStream.readObject();
            //if (response != "yes")
            {
                //System.out.println("response "+response);
                worldElement.println("startGame");
            }
            
            //set creature id based on constructor
            setId(0);
                       
        //in case host is not found, thrown exception    
        } catch (UnknownHostException ex) {
            ex.printStackTrace();
        //in case io stream problem, thrown exception
        } catch (IOException ex) {
            ex.printStackTrace();
       // } catch(ClassNotFoundException ex){
       //     System.err.println("data received in unknown format");
	}
    }
    public void moveForward()
    {
        movingForward = true;
        setAngle();
        worldElement.println("start "+id);
    }
    public void moveBackward()
    {
        movingBackward = true;
        setAngle();
        worldElement.println("start "+id);
    }
    public void stop()
    {
        worldElement.println("stop "+id);
        movingBackward = false;
        movingForward = false;
    }
    public void turnRight(int value)
    {
        angle = angle+value;
        angle = angle%360;
        setAngle();
    }
    public void turnLeft(int value)
    {
        angle = angle-value;
        angle = angle%360;
        setAngle();
    }
    public void setId(int value)
    {
        id = value;
    }
    public void refuel()
    {
        worldElement.println("refuel "+id);
    }
    public void increaseSpeed()
    {
        speed = speed + 1;
        setAngle();
    }
    public void decreaseSpeed()
    {
        speed = speed - 1;
        setAngle();
    }
    public void setSpeed(int value)
    {
        speed = value;
        setAngle();
    }
    public void getView()
    {
    }
    public void setAngle()
    {
        if (movingForward)
        {
            worldElement.println("setAngle "+id+" "+speed+" "+speed+" "+Math.toRadians(angle));
        }
        else
        {
            worldElement.println("setAngle "+id+" -"+speed+" -"+speed+" "+Math.toRadians(angle));
        }
    }
}

