/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package worldclient;

import java.awt.event.*; 
import javax.swing.*;
/**
 *
 * @author Guilherme
 */
public class MoveControl extends JFrame implements KeyListener {
    private WorldClient client;
    private boolean movingForward = false;
    private boolean movingBackward = false;
    
    public static void main(String[] args) { 
        new MoveControl();
    } 

    public  MoveControl() 
    {
            this.addKeyListener(this);
            this.setSize(300,300); 
            this.setVisible(true); 
            //try{
            client = new WorldClient(0);
            System.out.println("0");
            //} catch(ClassNotFoundException ex){
            //System.err.println("data received in unknown format");
            //}
    }

    public void keyPressed(KeyEvent e)
    {
      switch(e.getKeyCode())
      {
         case KeyEvent.VK_LEFT: 
             client.turnLeft(15);
             break;
         case KeyEvent.VK_RIGHT: 
             client.turnRight(15);
             break;
         case KeyEvent.VK_UP:
             if (!movingForward)
             {
                client.moveForward();
                movingForward = true;
             }
             break;
         case KeyEvent.VK_DOWN: 
             if (!movingBackward)
             {
                client.moveBackward();
                movingBackward = true;
             }
             break;
         case KeyEvent.VK_PLUS: 
             client.increaseSpeed();
             break;
         case KeyEvent.VK_MINUS: 
             client.decreaseSpeed();
             break;
         case KeyEvent.VK_SPACE: 
             client.refuel();
             break;
         case KeyEvent.VK_1: 
             client.setSpeed(1);
             break;
         case KeyEvent.VK_2: 
             client.setSpeed(2);
             break;
         case KeyEvent.VK_3: 
             client.setSpeed(3);
             break;
         case KeyEvent.VK_4: 
             client.setSpeed(4);
             break;
         case KeyEvent.VK_5: 
             client.setSpeed(5);
             break;
         case KeyEvent.VK_6: 
             client.setSpeed(6);
             break;
         case KeyEvent.VK_7: 
             client.setSpeed(7);
             break;
         case KeyEvent.VK_8: 
             client.setSpeed(8);
             break;
         case KeyEvent.VK_9: 
             client.setSpeed(9);
             break;
         case KeyEvent.VK_0: 
             client.setSpeed(0);
             break;
         //ect...
      }
    }

    public void keyReleased(KeyEvent e)
    {
      switch(e.getKeyCode())
      {
         case KeyEvent.VK_UP: 
             client.stop();
             movingForward = false;
             break;
         case KeyEvent.VK_DOWN: 
             client.stop();
             movingBackward = false;
             break;
      }
    }

    public void keyTyped(KeyEvent e) 
    {
    }
}






/*


private void actionLoop()
{
  if(leftKey && downKey)
     moveLD();
  else if(leftKey && upKey)
     moveLU();
  else if(leftKey)
     moveL();
  else if(rightKey && downKey)
     moveRD();
  else if(rightKey && upKey)
     moveRU();
  else if(rightKey)
     moveR();
  else if(downKey)
     moveD();
  else if(upKey)
     moveU();
  
  if(fireKey)
  {
     fire();
     fireKey = false;
  }
  //ect...
}*/ 